<?php
$currentBattle = 'battle_state.json';

if (!file_exists($currentBattle)) {
    file_put_contents($currentBattle, json_encode([
        'fighters' => [],
        'moves' => [],
        'last_fighter' => null,
        'battle_end' => false,
        'winner' => null,
        'game_mode' => null,
    ]));
}

$battleState = json_decode(file_get_contents($currentBattle), true);

if ($_SERVER['REQUEST_METHOD'] === 'POST') {
    $action = $_POST['action'];
    $username = $_POST['username'];

    if ($action === 'join') {
        $gameMode = $_POST['gameMode'];
        $team = $_POST['team'];
        $fighterExists = false;
        foreach ($battleState['fighters'] as $fighter) {
            if ($username === $fighter['name']) {
                $fighterExists = true;
                break;
            }
        }

        if (!$fighterExists) {
            // Устанавливаем режим игры только при входе первого игрока
            if (empty($battleState['fighters'])) {
                $battleState['game_mode'] = $gameMode; //Ошибки нет, данные пишутся в json по окончанию.
            }

            $battleState['fighters'][] = [
                'name' => $username,
                'hp' => 100,
                'attack' => 10,
                'team' => ($gameMode === 'team' ? $team : null),
            ];
        }

    } elseif ($action === 'move' && !$battleState['battle_end']) {
        $attackerIndex = -1;
        foreach ($battleState['fighters'] as $index => $fighter) {
            if ($fighter['name'] === $username) {
                $attackerIndex = $index;
                break;
            }
        }

        if ($attackerIndex !== -1 && $battleState['fighters'][$attackerIndex]['hp'] > 0) {
            if ($battleState['last_fighter'] !== $username) {
                $move = $_POST['move'];
                $target = $_POST['target'];
                $battleState['moves'][] = ['fighter' => $username, 'move' => $move, 'target' => $target];
                $battleState['last_fighter'] = $username;

                $targetIndex = -1;
                foreach ($battleState['fighters'] as $index => $fighter) {
                    if ($fighter['name'] === $target) {
                        $targetIndex = $index;
                        break;
                    }
                }

                if ($targetIndex !== -1) {
                    $battleState['fighters'][$targetIndex]['hp'] -= $battleState['fighters'][$attackerIndex]['attack'];
                    if ($battleState['fighters'][$targetIndex]['hp'] <= 0) {
                        $battleState['fighters'][$targetIndex]['hp'] = 0;
                    }

                    $aliveTeams = [];
                    $aliveFighters = [];

                    foreach ($battleState['fighters'] as $fighter) {
                        if ($fighter['hp'] > 0) {
                            if ($fighter['team']) {
                                $aliveTeams[$fighter['team']] = true;
                            }
                            $aliveFighters[] = $fighter;
                        }
                    }

                    if ($battleState['game_mode'] === 'team' && count($aliveTeams) === 1) {
                        $battleState['battle_end'] = true;
                        $battleState['winner'] = ['team' => array_keys($aliveTeams)[0]];
                    } elseif ($battleState['game_mode'] === 'solo' && count($aliveFighters) === 1) {
                        $battleState['battle_end'] = true;
                        $battleState['winner'] = ['name' => $aliveFighters[0]['name']];
                    }

                }
            } else {
                echo json_encode(['error' => 'Not your turn!']);
                exit;
            }
        } else {
            echo json_encode(['error' => 'You are dead!']);
            exit();
        }
    }

    file_put_contents($currentBattle, json_encode($battleState));
    echo json_encode($battleState);
} elseif ($_SERVER['REQUEST_METHOD'] === 'GET') {
    echo json_encode($battleState);
}


